]> git.ipfire.org Git - thirdparty/git.git/blame - git-bisect.sh
git-rerere.txt: grammatical fixups and cleanups
[thirdparty/git.git] / git-bisect.sh
CommitLineData
8cc6a083 1#!/bin/sh
d025524d 2
243a60fb
CC
3USAGE='[help|start|bad|good|skip|next|reset|visualize|replay|log|run]'
4LONG_USAGE='git bisect help
5 print this long help message.
6git bisect start [<bad> [<good>...]] [--] [<pathspec>...]
38a47fd6
CC
7 reset bisect state and start bisection.
8git bisect bad [<rev>]
9 mark <rev> a known-bad revision.
10git bisect good [<rev>...]
11 mark <rev>... known-good revisions.
6ca8b977
CC
12git bisect skip [<rev>...]
13 mark <rev>... untestable revisions.
38a47fd6
CC
14git bisect next
15 find next bisection to test and check it out.
16git bisect reset [<branch>]
17 finish bisection search and go back to branch.
18git bisect visualize
19 show bisect status in gitk.
20git bisect replay <logfile>
21 replay bisection log.
22git bisect log
23 show bisect log.
24git bisect run <cmd>...
243a60fb
CC
25 use <cmd>... to automatically bisect.
26
27Please use "git help bisect" to get the full man page.'
d025524d 28
8f321a39 29OPTIONS_SPEC=
ae2b0f15 30. git-sh-setup
4c550686 31require_work_tree
8cc6a083 32
ce32660e
JS
33_x40='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
34_x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
35
e9a45d75 36sq() {
d9bffc08 37 @@PERL@@ -e '
e9a45d75
JH
38 for (@ARGV) {
39 s/'\''/'\'\\\\\'\''/g;
40 print " '\''$_'\''";
41 }
42 print "\n";
43 ' "$@"
44}
45
8cc6a083 46bisect_autostart() {
823ea121 47 test -s "$GIT_DIR/BISECT_START" || {
8cc6a083
LT
48 echo >&2 'You need to start by "git bisect start"'
49 if test -t 0
50 then
51 echo >&2 -n 'Do you want me to do it for you [Y/n]? '
52 read yesno
53 case "$yesno" in
54 [Nn]*)
55 exit ;;
56 esac
57 bisect_start
58 else
59 exit 1
60 fi
61 }
62}
63
64bisect_start() {
8cc6a083 65 #
634f2464 66 # Verify HEAD.
8cc6a083 67 #
48949a18 68 head=$(GIT_DIR="$GIT_DIR" git symbolic-ref -q HEAD) ||
ce32660e
JS
69 head=$(GIT_DIR="$GIT_DIR" git rev-parse --verify HEAD) ||
70 die "Bad HEAD - I need a HEAD"
634f2464 71
ee831f7d 72 #
634f2464 73 # Check if we are bisecting.
ee831f7d 74 #
d3e54c88 75 start_head=''
634f2464
CC
76 if test -s "$GIT_DIR/BISECT_START"
77 then
78 # Reset to the rev from where we started.
9d0cd91c
CC
79 start_head=$(cat "$GIT_DIR/BISECT_START")
80 git checkout "$start_head" || exit
634f2464
CC
81 else
82 # Get rev from where we start.
83 case "$head" in
84 refs/heads/*|$_x40)
85 # This error message should only be triggered by
86 # cogito usage, and cogito users should understand
87 # it relates to cg-seek.
88 [ -s "$GIT_DIR/head-name" ] &&
89 die "won't bisect on seeked tree"
90 start_head="${head#refs/heads/}"
91 ;;
92 *)
93 die "Bad HEAD - strange symbolic ref"
94 ;;
95 esac
96 fi
8cc6a083
LT
97
98 #
634f2464 99 # Get rid of any old bisect state.
8cc6a083 100 #
823ea121 101 bisect_clean_state || exit
38a47fd6
CC
102
103 #
104 # Check for one bad and then some good revisions.
105 #
106 has_double_dash=0
107 for arg; do
108 case "$arg" in --) has_double_dash=1; break ;; esac
109 done
110 orig_args=$(sq "$@")
111 bad_seen=0
d3e54c88 112 eval=''
38a47fd6
CC
113 while [ $# -gt 0 ]; do
114 arg="$1"
115 case "$arg" in
116 --)
8fe26f44 117 shift
38a47fd6
CC
118 break
119 ;;
120 *)
634f2464 121 rev=$(git rev-parse -q --verify "$arg^{commit}") || {
38a47fd6
CC
122 test $has_double_dash -eq 1 &&
123 die "'$arg' does not appear to be a valid revision"
124 break
125 }
737c74ee
CC
126 case $bad_seen in
127 0) state='bad' ; bad_seen=1 ;;
128 *) state='good' ;;
129 esac
d3e54c88 130 eval="$eval bisect_write '$state' '$rev' 'nolog'; "
8fe26f44 131 shift
38a47fd6
CC
132 ;;
133 esac
8fe26f44 134 done
38a47fd6 135
ba963de8
CC
136 #
137 # Change state.
138 # In case of mistaken revs or checkout error, or signals received,
139 # "bisect_auto_next" below may exit or misbehave.
140 # We have to trap this to be able to clean up using
141 # "bisect_clean_state".
142 #
143 trap 'bisect_clean_state' 0
144 trap 'exit 255' 1 2 3 15
145
146 #
147 # Write new start state.
148 #
ba963de8 149 echo "$start_head" >"$GIT_DIR/BISECT_START" &&
823ea121 150 sq "$@" >"$GIT_DIR/BISECT_NAMES" &&
ba963de8 151 eval "$eval" &&
6c98c054 152 echo "git bisect start$orig_args" >>"$GIT_DIR/BISECT_LOG" || exit
ba963de8
CC
153 #
154 # Check if we can proceed to the next bisect state.
155 #
38a47fd6 156 bisect_auto_next
ba963de8
CC
157
158 trap '-' 0
8cc6a083
LT
159}
160
55624f9a
CC
161bisect_write() {
162 state="$1"
163 rev="$2"
737c74ee 164 nolog="$3"
55624f9a
CC
165 case "$state" in
166 bad) tag="$state" ;;
167 good|skip) tag="$state"-"$rev" ;;
168 *) die "Bad bisect_write argument: $state" ;;
169 esac
ba963de8 170 git update-ref "refs/bisect/$tag" "$rev" || exit
f454cdc4 171 echo "# $state: $(git show-branch $rev)" >>"$GIT_DIR/BISECT_LOG"
6c98c054 172 test -n "$nolog" || echo "git bisect $state $rev" >>"$GIT_DIR/BISECT_LOG"
55624f9a
CC
173}
174
155fc795 175bisect_state() {
8cc6a083 176 bisect_autostart
155fc795
CC
177 state=$1
178 case "$#,$state" in
179 0,*)
180 die "Please call 'bisect_state' with at least one argument." ;;
181 1,bad|1,good|1,skip)
182 rev=$(git rev-parse --verify HEAD) ||
183 die "Bad rev input: HEAD"
184 bisect_write "$state" "$rev" ;;
e3389075 185 2,bad|*,good|*,skip)
155fc795 186 shift
d3e54c88 187 eval=''
e3389075 188 for rev in "$@"
155fc795 189 do
a179a303 190 sha=$(git rev-parse --verify "$rev^{commit}") ||
e3389075 191 die "Bad rev input: $rev"
d3e54c88
CC
192 eval="$eval bisect_write '$state' '$sha'; "
193 done
194 eval "$eval" ;;
e3389075
CC
195 *,bad)
196 die "'git bisect bad' can take only one argument." ;;
cc9f24d0
JH
197 *)
198 usage ;;
8cc6a083 199 esac
97e1c51e
CC
200 bisect_auto_next
201}
202
8cc6a083 203bisect_next_check() {
0a5280a9
JH
204 missing_good= missing_bad=
205 git show-ref -q --verify refs/bisect/bad || missing_bad=t
206 test -n "$(git for-each-ref "refs/bisect/good-*")" || missing_good=t
6fecf191 207
0a5280a9
JH
208 case "$missing_good,$missing_bad,$1" in
209 ,,*)
210 : have both good and bad - ok
211 ;;
212 *,)
213 # do not have both but not asked to fail - just report.
214 false
215 ;;
216 t,,good)
217 # have bad but not good. we could bisect although
218 # this is less optimum.
219 echo >&2 'Warning: bisecting only with a bad commit.'
220 if test -t 0
221 then
222 printf >&2 'Are you sure [Y/n]? '
e5d3afd7
FM
223 read yesno
224 case "$yesno" in [Nn]*) exit 1 ;; esac
0a5280a9
JH
225 fi
226 : bisect without good...
227 ;;
8cc6a083 228 *)
0a5280a9 229 THEN=''
823ea121 230 test -s "$GIT_DIR/BISECT_START" || {
0a5280a9
JH
231 echo >&2 'You need to start by "git bisect start".'
232 THEN='then '
233 }
234 echo >&2 'You '$THEN'need to give me at least one good' \
235 'and one bad revisions.'
236 echo >&2 '(You can use "git bisect bad" and' \
237 '"git bisect good" for that.)'
238 exit 1 ;;
8cc6a083
LT
239 esac
240}
241
242bisect_auto_next() {
434d036f 243 bisect_next_check && bisect_next || :
8cc6a083
LT
244}
245
42ba5ee7
CC
246eval_rev_list() {
247 _eval="$1"
248
249 eval $_eval
250 res=$?
251
252 if [ $res -ne 0 ]; then
253 echo >&2 "'git rev-list --bisect-vars' failed:"
254 echo >&2 "maybe you mistake good and bad revs?"
255 exit $res
256 fi
257
258 return $res
259}
260
97e1c51e
CC
261filter_skipped() {
262 _eval="$1"
263 _skip="$2"
264
265 if [ -z "$_skip" ]; then
cce074a2
CC
266 eval_rev_list "$_eval" | {
267 while read line
268 do
269 echo "$line &&"
270 done
271 echo ':'
272 }
97e1c51e
CC
273 return
274 fi
275
276 # Let's parse the output of:
277 # "git rev-list --bisect-vars --bisect-all ..."
1b249ffe
CC
278 eval_rev_list "$_eval" | {
279 VARS= FOUND= TRIED=
280 while read hash line
281 do
282 case "$VARS,$FOUND,$TRIED,$hash" in
283 1,*,*,*)
284 # "bisect_foo=bar" read from rev-list output.
285 echo "$hash &&"
286 ;;
287 ,*,*,---*)
288 # Separator
289 ;;
97e1c51e 290 ,,,bisect_rev*)
1b249ffe
CC
291 # We had nothing to search.
292 echo "bisect_rev= &&"
97e1c51e
CC
293 VARS=1
294 ;;
97e1c51e 295 ,,*,bisect_rev*)
1b249ffe
CC
296 # We did not find a good bisect rev.
297 # This should happen only if the "bad"
298 # commit is also a "skip" commit.
299 echo "bisect_rev='$TRIED' &&"
97e1c51e
CC
300 VARS=1
301 ;;
97e1c51e 302 ,,*,*)
1b249ffe 303 # We are searching.
97e1c51e
CC
304 TRIED="${TRIED:+$TRIED|}$hash"
305 case "$_skip" in
306 *$hash*) ;;
307 *)
1b249ffe
CC
308 echo "bisect_rev=$hash &&"
309 echo "bisect_tried='$TRIED' &&"
97e1c51e
CC
310 FOUND=1
311 ;;
312 esac
313 ;;
1b249ffe
CC
314 ,1,*,bisect_rev*)
315 # We have already found a rev to be tested.
316 VARS=1
317 ;;
318 ,1,*,*)
319 ;;
320 *)
321 # Unexpected input
322 echo "die 'filter_skipped error'"
323 die "filter_skipped error " \
324 "VARS: '$VARS' " \
325 "FOUND: '$FOUND' " \
326 "TRIED: '$TRIED' " \
327 "hash: '$hash' " \
328 "line: '$line'"
329 ;;
330 esac
331 done
332 echo ':'
333 }
97e1c51e
CC
334}
335
336exit_if_skipped_commits () {
337 _tried=$1
338 if expr "$_tried" : ".*[|].*" > /dev/null ; then
339 echo "There are only 'skip'ped commit left to test."
340 echo "The first bad commit could be any of:"
e23cb8c0 341 echo "$_tried" | tr '[|]' '[\012]'
97e1c51e
CC
342 echo "We cannot bisect more!"
343 exit 2
344 fi
345}
346
8cc6a083 347bisect_next() {
8fe26f44 348 case "$#" in 0) ;; *) usage ;; esac
8cc6a083 349 bisect_autostart
0a5280a9
JH
350 bisect_next_check good
351
97e1c51e 352 skip=$(git for-each-ref --format='%(objectname)' \
40a7ce64 353 "refs/bisect/skip-*" | tr '\012' ' ') || exit
97e1c51e
CC
354
355 BISECT_OPT=''
356 test -n "$skip" && BISECT_OPT='--bisect-all'
357
5be60078 358 bad=$(git rev-parse --verify refs/bisect/bad) &&
0a5280a9 359 good=$(git for-each-ref --format='^%(objectname)' \
40a7ce64 360 "refs/bisect/good-*" | tr '\012' ' ') &&
97e1c51e 361 eval="git rev-list --bisect-vars $BISECT_OPT $good $bad --" &&
0a5280a9 362 eval="$eval $(cat "$GIT_DIR/BISECT_NAMES")" &&
97e1c51e 363 eval=$(filter_skipped "$eval" "$skip") &&
0a5280a9
JH
364 eval "$eval" || exit
365
366 if [ -z "$bisect_rev" ]; then
367 echo "$bad was both good and bad"
368 exit 1
670f5fe3 369 fi
0a5280a9 370 if [ "$bisect_rev" = "$bad" ]; then
97e1c51e 371 exit_if_skipped_commits "$bisect_tried"
0a5280a9 372 echo "$bisect_rev is first bad commit"
5be60078 373 git diff-tree --pretty $bisect_rev
0a5280a9 374 exit 0
8cc6a083 375 fi
0a5280a9 376
97e1c51e
CC
377 # We should exit here only if the "bad"
378 # commit is also a "skip" commit (see above).
379 exit_if_skipped_commits "$bisect_rev"
380
0a5280a9 381 echo "Bisecting: $bisect_nr revisions left to test after this"
634f2464 382 git checkout -q "$bisect_rev" || exit
5be60078 383 git show-branch "$bisect_rev"
8cc6a083
LT
384}
385
cc9f24d0
JH
386bisect_visualize() {
387 bisect_next_check fail
235997c9
JH
388
389 if test $# = 0
390 then
508e84a7 391 case "${DISPLAY+set}${MSYSTEM+set}${SECURITYSESSIONID+set}" in
235997c9 392 '') set git log ;;
508e84a7 393 set*) set gitk ;;
235997c9
JH
394 esac
395 else
396 case "$1" in
397 git*|tig) ;;
398 -*) set git log "$@" ;;
399 *) set git "$@" ;;
400 esac
401 fi
402
e3f062bf 403 not=$(git for-each-ref --format='%(refname)' "refs/bisect/good-*")
235997c9 404 eval '"$@"' refs/bisect/bad --not $not -- $(cat "$GIT_DIR/BISECT_NAMES")
cc9f24d0
JH
405}
406
8cc6a083 407bisect_reset() {
823ea121 408 test -s "$GIT_DIR/BISECT_START" || {
fce0499f
CC
409 echo "We are not bisecting."
410 return
411 }
8cc6a083 412 case "$#" in
823ea121 413 0) branch=$(cat "$GIT_DIR/BISECT_START") ;;
737c74ee
CC
414 1) git show-ref --verify --quiet -- "refs/heads/$1" ||
415 die "$1 does not seem to be a valid branch"
8cc6a083 416 branch="$1" ;;
8fe26f44 417 *)
8cc6a083
LT
418 usage ;;
419 esac
9d0cd91c 420 git checkout "$branch" && bisect_clean_state
e204de28
JH
421}
422
38a47fd6 423bisect_clean_state() {
947a604b 424 # There may be some refs packed during bisection.
634f2464 425 git for-each-ref --format='%(refname) %(objectname)' refs/bisect/\* |
947a604b
CC
426 while read ref hash
427 do
823ea121 428 git update-ref -d $ref $hash || exit
947a604b 429 done
823ea121
CC
430 rm -f "$GIT_DIR/BISECT_LOG" &&
431 rm -f "$GIT_DIR/BISECT_NAMES" &&
432 rm -f "$GIT_DIR/BISECT_RUN" &&
9d0cd91c 433 # Cleanup head-name if it got left by an old version of git-bisect
823ea121
CC
434 rm -f "$GIT_DIR/head-name" &&
435
436 rm -f "$GIT_DIR/BISECT_START"
38a47fd6
CC
437}
438
e204de28 439bisect_replay () {
737c74ee 440 test -r "$1" || die "cannot read $1 for replaying"
e204de28 441 bisect_reset
6c98c054 442 while read git bisect command rev
e204de28 443 do
6c98c054
MV
444 test "$git $bisect" = "git bisect" -o "$git" = "git-bisect" || continue
445 if test "$git" = "git-bisect"; then
446 rev="$command"
447 command="$bisect"
448 fi
e204de28
JH
449 case "$command" in
450 start)
e9a45d75 451 cmd="bisect_start $rev"
737c74ee
CC
452 eval "$cmd" ;;
453 good|bad|skip)
454 bisect_write "$command" "$rev" ;;
e204de28 455 *)
737c74ee 456 die "?? what are you talking about?" ;;
e204de28
JH
457 esac
458 done <"$1"
459 bisect_auto_next
8cc6a083
LT
460}
461
a17c4101 462bisect_run () {
83020120
CC
463 bisect_next_check fail
464
a17c4101
CC
465 while true
466 do
467 echo "running $@"
468 "$@"
469 res=$?
470
471 # Check for really bad run error.
472 if [ $res -lt 0 -o $res -ge 128 ]; then
473 echo >&2 "bisect run failed:"
474 echo >&2 "exit code $res from '$@' is < 0 or >= 128"
475 exit $res
476 fi
477
155fc795 478 # Find current state depending on run success or failure.
71b0251c
CC
479 # A special exit code of 125 means cannot test.
480 if [ $res -eq 125 ]; then
481 state='skip'
482 elif [ $res -gt 0 ]; then
155fc795 483 state='bad'
a17c4101 484 else
155fc795 485 state='good'
a17c4101
CC
486 fi
487
155fc795
CC
488 # We have to use a subshell because "bisect_state" can exit.
489 ( bisect_state $state > "$GIT_DIR/BISECT_RUN" )
a17c4101
CC
490 res=$?
491
492 cat "$GIT_DIR/BISECT_RUN"
493
71b0251c
CC
494 if grep "first bad commit could be any of" "$GIT_DIR/BISECT_RUN" \
495 > /dev/null; then
496 echo >&2 "bisect run cannot continue any more"
497 exit $res
498 fi
499
a17c4101
CC
500 if [ $res -ne 0 ]; then
501 echo >&2 "bisect run failed:"
155fc795 502 echo >&2 "'bisect_state $state' exited with error code $res"
a17c4101
CC
503 exit $res
504 fi
505
506 if grep "is first bad commit" "$GIT_DIR/BISECT_RUN" > /dev/null; then
507 echo "bisect run success"
508 exit 0;
509 fi
510
511 done
512}
513
514
8cc6a083
LT
515case "$#" in
5160)
517 usage ;;
518*)
519 cmd="$1"
520 shift
521 case "$cmd" in
243a60fb
CC
522 help)
523 git bisect -h ;;
8cc6a083
LT
524 start)
525 bisect_start "$@" ;;
155fc795
CC
526 bad|good|skip)
527 bisect_state "$cmd" "$@" ;;
8cc6a083
LT
528 next)
529 # Not sure we want "next" at the UI level anymore.
530 bisect_next "$@" ;;
235997c9 531 visualize|view)
cc9f24d0 532 bisect_visualize "$@" ;;
8cc6a083
LT
533 reset)
534 bisect_reset "$@" ;;
e204de28
JH
535 replay)
536 bisect_replay "$@" ;;
537 log)
538 cat "$GIT_DIR/BISECT_LOG" ;;
a17c4101
CC
539 run)
540 bisect_run "$@" ;;
8cc6a083
LT
541 *)
542 usage ;;
543 esac
544esac